Subject: bug#66117: 30.0.50; `find-buffer-visiting' is slow when opening large number of buffers

From: Stefan Monnier <[email-masked]>
Date: Tue, 12 Dec 2023 22:50:54 -0500

> Perhaps in the long run it might be good to do the opposite? Introduce
> never-buffer-local variables, and make case-fold-search one of them.
>
> I do see a few hits for
>
>   (setq-local case-fold-search
>
> across the Emacs codebase, but in none of these I can clearly understand the
>  end goal (is that for interactive isearch?).

If it's really rare, then the simpler&better solution is to move it out
of the `struct buffer` altogether (i.e. make it normal DEFVAR_LISP or
DEFVAR_BOOL).

>  Except for
>  ido-make-buffer-list-1, which is done purely for performance, working
>  around a problem related to what's being discussed here (df4991093b94).

Of course, ideally there should be no such var for `re-search-*`
and friends.  Such vars are good for user-configs impacting the behavior
of commands but they're a bit clunky when used as implicit parameters to
low-level ELisp primitives.

        Stefan